Overview | Package | Class | Tree | Deprecated | Index | Help
| TIBCO Enterprise Message Service
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.tibco.tibems.ufo
Class TibjmsUFOConnection

    java.lang.Object
      com.tibco.tibems.ufo.TibjmsUFOConnection

All Implemented Interfaces:
  Connection

Direct Known Subclasses:
  TibjmsUFOQueueConnection, TibjmsUFOTopicConnection

    public class TibjmsUFOConnection

extends java.lang.Object
implements Connection

Method Summary
`void` | `close()` Closes the connection.
`ConnectionConsumer` | `createConnectionConsumer(Destination destination, java.lang.String messageSelector, ServerSessionPool sessionPool, int maxMessages)` Creates a connection consumer for this connection (optional operation).
`ConnectionConsumer` | `createDurableConnectionConsumer(Topic topic, java.lang.String subscriptionName, java.lang.String messageSelector, ServerSessionPool sessionPool, int maxMessages)` Create a durable connection consumer for this connection (optional operation).
`Session` | `createSession(boolean transacted, int acknowledgeMode)` Creates a `Session` object.
`java.lang.String` | `getClientID()` Gets the client identifier for this connection.
`ExceptionListener` | `getExceptionListener()` Gets the `ExceptionListener` object for this connection.
`ConnectionMetaData` | `getMetaData()` Gets the metadata for this connection.
`void` | `recoverConnection()` This method is used to recover the broken connection on another available server.
`void` | `setClientID(java.lang.String clientID)` Sets the client identifier for this connection.
`void` | `setExceptionListener(ExceptionListener listener)` Sets an exception listener for this connection.
`void` | `start()` Starts (or restarts) a connection's delivery of incoming messages.
`void` | `stop()` Temporarily stops a connection's delivery of incoming messages.
`java.lang.String` | `toString()`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Method Detail

### createConnectionConsumer

    public ConnectionConsumer createConnectionConsumer(Destination destination,
                                                       java.lang.String messageSelector,
                                                       ServerSessionPool sessionPool,
                                                       int maxMessages)
                                                throws JMSException

  Description copied from interface: `Connection`
  Creates a connection consumer for this connection (optional operation). This is an expert facility not used by regular JMS clients.

  Specified by:
    `createConnectionConsumer` in interface `Connection`
  Parameters:
    `destination` - the destination to access
    `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
    `sessionPool` - the server session pool to associate with this connection consumer
    `maxMessages` - the maximum number of messages that can be assigned to a server session at one time
  Returns:
    the connection consumer
  Throws:
    `JMSException` - if the `Connection` object fails to create a connection consumer due to some internal error or invalid arguments for `sessionPool` and `messageSelector`.
    `InvalidDestinationException` - if an invalid destination is specified.
    `InvalidSelectorException` - if the message selector is invalid.
  See Also:
    `ConnectionConsumer`

### createDurableConnectionConsumer

    public ConnectionConsumer createDurableConnectionConsumer(Topic topic,
                                                              java.lang.String subscriptionName,
                                                              java.lang.String messageSelector,
                                                              ServerSessionPool sessionPool,
                                                              int maxMessages)
                                                       throws JMSException

  Description copied from interface: `Connection`
  Create a durable connection consumer for this connection (optional operation). This is an expert facility not used by regular JMS clients.

  Specified by:
    `createDurableConnectionConsumer` in interface `Connection`
  Parameters:
    `topic` - topic to access
    `subscriptionName` - durable subscription name
    `messageSelector` - only messages with properties matching the message selector expression are delivered. A value of null or an empty string indicates that there is no message selector for the message consumer.
    `sessionPool` - the server session pool to associate with this durable connection consumer
    `maxMessages` - the maximum number of messages that can be assigned to a server session at one time
  Returns:
    the durable connection consumer
  Throws:
    `JMSException` - if the `Connection` object fails to create a connection consumer due to some internal error or invalid arguments for `sessionPool` and `messageSelector`.
    `InvalidDestinationException` - if an invalid destination is specified.
    `InvalidSelectorException` - if the message selector is invalid.
  See Also:
    `ConnectionConsumer`

### getClientID

    public java.lang.String getClientID()
                                 throws JMSException

  Description copied from interface: `Connection`
  Gets the client identifier for this connection.

  This value is specific to the JMS provider. It is either preconfigured by an administrator in a `ConnectionFactory` object or assigned dynamically by the application by calling the `setClientID` method.

  Specified by:
    `getClientID` in interface `Connection`
  Returns:
    the unique client identifier
  Throws:
    `JMSException` - if the JMS provider fails to return the client ID for this connection due to some internal error.

### setClientID

    public void setClientID(java.lang.String clientID)
                     throws JMSException

  Description copied from interface: `Connection`
  Sets the client identifier for this connection.

  The preferred way to assign a JMS client's client identifier is for it to be configured in a client-specific `ConnectionFactory` object and transparently assigned to the `Connection` object it creates.

  Alternatively, a client can set a connection's client identifier using a provider-specific value. The facility to set a connection's client identifier explicitly is not a mechanism for overriding the identifier that has been administratively configured. It is provided for the case where no administratively specified identifier exists. If one does exist, an attempt to change it by setting it must throw an `IllegalStateException`. If a client sets the client identifier explicitly, it must do so immediately after it creates the connection and before any other action on the connection is taken. After this point, setting the client identifier is a programming error that should throw an `IllegalStateException`.

  The purpose of the client identifier is to associate a connection and its objects with a state maintained on behalf of the client by a provider. The only such state identified by the JMS API is that required to support durable subscriptions.

  If another connection with the same `clientID` is already running when this method is called, the JMS provider should detect the duplicate ID and throw an `InvalidClientIDException`.

  Specified by:
    `setClientID` in interface `Connection`
  Parameters:
    `clientID` - the unique client identifier
  Throws:
    `JMSException` - if the JMS provider fails to set the client ID for this connection due to some internal error.
    `InvalidClientIDException` - if the JMS client specifies an invalid or duplicate client ID.
    `IllegalStateException` - if the JMS client attempts to set a connection's client ID at the wrong time or when it has been administratively configured.

### getMetaData

    public ConnectionMetaData getMetaData()
                                   throws JMSException

  Description copied from interface: `Connection`
  Gets the metadata for this connection.

  Specified by:
    `getMetaData` in interface `Connection`
  Returns:
    the connection metadata
  Throws:
    `JMSException` - if the JMS provider fails to get the connection metadata for this connection.
  See Also:
    `ConnectionMetaData`

### getExceptionListener

    public ExceptionListener getExceptionListener()
                                           throws JMSException

  Description copied from interface: `Connection`
  Gets the `ExceptionListener` object for this connection. Not every `Connection` has an `ExceptionListener` associated with it.

  Specified by:
    `getExceptionListener` in interface `Connection`
  Returns:
    the `ExceptionListener` for this connection, or null. if no `ExceptionListener` is associated with this connection.
  Throws:
    `JMSException` - if the JMS provider fails to get the `ExceptionListener` for this connection.
  See Also:
    `Connection.setExceptionListener(javax.jms.ExceptionListener)`

### createSession

    public Session createSession(boolean transacted,
                                 int acknowledgeMode)
                          throws JMSException

  Description copied from interface: `Connection`
  Creates a `Session` object.

  Specified by:
    `createSession` in interface `Connection`
  Parameters:
    `transacted` - indicates whether the session is transacted
    `acknowledgeMode` - indicates whether the consumer or the client will acknowledge any messages it receives; ignored if the session is transacted. Legal values are `Session.AUTO_ACKNOWLEDGE`, `Session.CLIENT_ACKNOWLEDGE`, and `Session.DUPS_OK_ACKNOWLEDGE`.
  Returns:
    a newly created session
  Throws:
    `JMSException` - if the `Connection` object fails to create a session due to some internal error or lack of support for the specific transaction and acknowledgement mode.
  See Also:
    `Session.AUTO_ACKNOWLEDGE`, `Session.CLIENT_ACKNOWLEDGE`, `Session.DUPS_OK_ACKNOWLEDGE`

### setExceptionListener

    public void setExceptionListener(ExceptionListener listener)
                              throws JMSException

  Description copied from interface: `Connection`
  Sets an exception listener for this connection.

  If a JMS provider detects a serious problem with a connection, it informs the connection's `ExceptionListener`, if one has been registered. It does this by calling the listener's `onException` method, passing it a `JMSException` object describing the problem.

  An exception listener allows a client to be notified of a problem asynchronously. Some connections only consume messages, so they would have no other way to learn their connection has failed.

  A connection serializes execution of its `ExceptionListener`.

  A JMS provider should attempt to resolve connection problems itself before it notifies the client of them.

  Specified by:
    `setExceptionListener` in interface `Connection`
  Parameters:
    `listener` - the exception listener
  Throws:
    `JMSException` - if the JMS provider fails to set the exception listener for this connection.

### start

    public void start()
               throws JMSException

  Description copied from interface: `Connection`
  Starts (or restarts) a connection's delivery of incoming messages. A call to `start` on a connection that has already been started is ignored.

  Specified by:
    `start` in interface `Connection`
  Throws:
    `JMSException` - if the JMS provider fails to start message delivery due to some internal error.
  See Also:
    `Connection.stop()`

### stop

    public void stop()
              throws JMSException

  Description copied from interface: `Connection`
  Temporarily stops a connection's delivery of incoming messages. Delivery can be restarted using the connection's `start` method. When the connection is stopped, delivery to all the connection's message consumers is inhibited: synchronous receives block, and messages are not delivered to message listeners.

  This call blocks until receives and/or message listeners in progress have completed.

  Stopping a connection has no effect on its ability to send messages. A call to `stop` on a connection that has already been stopped is ignored.

  A call to `stop` must not return until delivery of messages has paused. This means that a client can rely on the fact that none of its message listeners will be called and that all threads of control waiting for `receive` calls to return will not return with a message until the connection is restarted. The receive timers for a stopped connection continue to advance, so receives may time out while the connection is stopped.

  If message listeners are running when `stop` is invoked, the `stop` call must wait until all of them have returned before it may return. While these message listeners are completing, they must have the full services of the connection available to them.

  Specified by:
    `stop` in interface `Connection`
  Throws:
    `JMSException` - if the JMS provider fails to stop message delivery due to some internal error.
  See Also:
    `Connection.start()`

### close

    public void close()
               throws JMSException

  Description copied from interface: `Connection`
  Closes the connection.

  Since a provider typically allocates significant resources outside the JVM on behalf of a connection, clients should close these resources when they are not needed. Relying on garbage collection to eventually reclaim these resources may not be timely enough.

  There is no need to close the sessions, producers, and consumers of a closed connection.

  Closing a connection causes all temporary destinations to be deleted.

  When this method is invoked, it should not return until message processing has been shut down in an orderly fashion. This means that all message listeners that may have been running have returned, and that all pending receives have returned. A close terminates all pending message receives on the connection's sessions' consumers. The receives may return with a message or with null, depending on whether there was a message available at the time of the close. If one or more of the connection's sessions' message listeners is processing a message at the time when connection `close` is invoked, all the facilities of the connection and its sessions must remain available to those listeners until they return control to the JMS provider.

  Closing a connection causes any of its sessions' transactions in progress to be rolled back. In the case where a session's work is coordinated by an external transaction manager, a session's `commit` and `rollback` methods are not used and the result of a closed session's work is determined later by the transaction manager. Closing a connection does NOT force an acknowledgment of client-acknowledged sessions.

  Invoking the `acknowledge` method of a received message from a closed connection's session must throw an `IllegalStateException`. Closing a closed connection must NOT throw an exception.

  Specified by:
    `close` in interface `Connection`
  Throws:
    `JMSException` - if the JMS provider fails to close the connection due to some internal error. For example, a failure to release resources or to close a socket connection can cause this exception to be thrown.

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### recoverConnection

    public void recoverConnection()
                           throws JMSException

  This method is used to recover the broken connection on another available server. The sessions, message producers, message consumers, temporary destinations created by this broken connection are transparently recreated once the connection is recovered.

  Throws:
    `JMSException`

Overview | Package | Class | Tree | Deprecated | Index | Help
| TIBCO Enterprise Message Service
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © TIBCO Software Inc. All rights reserved